Attribute VB_Name = "MatrixModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

Public myYMatrix As D3DMATRIX
Public myXMatrix As D3DMATRIX
Public myTranslateMatrix As D3DMATRIX
Public myNewMatrix As D3DMATRIX

Public Sub TranslateMatrix(m As D3DMATRIX, v As D3DVECTOR)
    m.rc41 = v.x
    m.rc42 = v.y
    m.rc43 = v.z
End Sub

Public Function RetMatrixMult(a As D3DMATRIX, b As D3DMATRIX) As D3DMATRIX
    Dim ret As D3DMATRIX
    ret.rc11 = b.rc11 * a.rc11 + b.rc21 * a.rc12 + b.rc31 * a.rc13 + b.rc41 * a.rc14
    ret.rc12 = b.rc12 * a.rc11 + b.rc22 * a.rc12 + b.rc32 * a.rc13 + b.rc42 * a.rc14
    ret.rc13 = b.rc13 * a.rc11 + b.rc23 * a.rc12 + b.rc33 * a.rc13 + b.rc43 * a.rc14
    ret.rc14 = b.rc14 * a.rc11 + b.rc24 * a.rc12 + b.rc34 * a.rc13 + b.rc44 * a.rc14
    ret.rc21 = b.rc11 * a.rc21 + b.rc21 * a.rc22 + b.rc31 * a.rc23 + b.rc41 * a.rc24
    ret.rc22 = b.rc12 * a.rc21 + b.rc22 * a.rc22 + b.rc32 * a.rc23 + b.rc42 * a.rc24
    ret.rc23 = b.rc13 * a.rc21 + b.rc23 * a.rc22 + b.rc33 * a.rc23 + b.rc43 * a.rc24
    ret.rc24 = b.rc14 * a.rc21 + b.rc24 * a.rc22 + b.rc34 * a.rc23 + b.rc44 * a.rc24
    ret.rc31 = b.rc11 * a.rc31 + b.rc21 * a.rc32 + b.rc31 * a.rc33 + b.rc41 * a.rc34
    ret.rc32 = b.rc12 * a.rc31 + b.rc22 * a.rc32 + b.rc32 * a.rc33 + b.rc42 * a.rc34
    ret.rc33 = b.rc13 * a.rc31 + b.rc23 * a.rc32 + b.rc33 * a.rc33 + b.rc43 * a.rc34
    ret.rc34 = b.rc14 * a.rc31 + b.rc24 * a.rc32 + b.rc34 * a.rc33 + b.rc44 * a.rc34
    ret.rc41 = b.rc11 * a.rc41 + b.rc21 * a.rc42 + b.rc31 * a.rc43 + b.rc41 * a.rc44
    ret.rc42 = b.rc12 * a.rc41 + b.rc22 * a.rc42 + b.rc32 * a.rc43 + b.rc42 * a.rc44
    ret.rc43 = b.rc13 * a.rc41 + b.rc23 * a.rc42 + b.rc33 * a.rc43 + b.rc43 * a.rc44
    ret.rc44 = b.rc14 * a.rc41 + b.rc24 * a.rc42 + b.rc34 * a.rc43 + b.rc44 * a.rc44
    RetMatrixMult = ret
End Function

Public Sub RotateYMatrix(ByRef ret As D3DMATRIX, ByVal rads As Single)
    Dim cosine As Single
    Dim sine As Single
    cosine = Cos(rads)
    sine = Sin(rads)
    ret.rc11 = cosine
    ret.rc33 = cosine
    ret.rc13 = sine
    ret.rc31 = -sine
End Sub

Public Sub RotateXMatrix(ByRef ret As D3DMATRIX, ByVal rads As Single)
    Dim cosine As Single
    Dim sine As Single
    cosine = Cos(rads)
    sine = Sin(rads)
    ret.rc22 = cosine
    ret.rc33 = cosine
    ret.rc23 = -sine
    ret.rc32 = sine
End Sub

Public Sub RotateZMatrix(ByRef ret As D3DMATRIX, ByVal rads As Single)
    Dim cosine As Single
    Dim sine As Single
    cosine = Cos(rads)
    sine = Sin(rads)
    ret.rc11 = cosine
    ret.rc22 = cosine
    ret.rc12 = -sine
    ret.rc21 = sine
End Sub
